<template>
  <view-new
    :status="status"
    title="Dodaj osobę"
    sentTitle="Nowa osoba została dodana"
    :back="BACK"
  >
    <input-form v-on:model-submit="on_submit">
      <input-text-field
        :error="get_error_for('name')"
        name="Imię"
        v-model="name"
      />
      <input-text-field
        :error="get_error_for('surname')"
        name="Nazwisko"
        v-model="surname"
      />
      <input-text-field
        :error="get_error_for('email')"
        name="Email"
        v-model="email"
      />
      <input-radio
        v-model="perm_id"
        :error="get_error_for('perm_id')"
        name="Uprawnienia"
        :list="perms"
      />
      <input-text-field
        :error="get_error_for('password')"
        name="Hasło"
        v-model="password"
        type="password"
        :size="2"
      />
      <div
        v-for="error in errors.filter((e) => e.field == null)"
        :style="{ gridColumnEnd: `span 2` }"
        :key="error.error"
        class="error"
      >
        {{ error.error }}
      </div>
      <input-button size="2" :spinner="status == formStatus.sending"
        >Dodaj nową osobę</input-button
      >
    </input-form>
  </view-new>
</template>

<script lang="ts">
import { Options, Vue } from "vue-class-component";

import NewRecord from "@/views/new-views/NewRecord.ts";

import InputButton from "@/components/input/InputButton.vue";
import InputForm from "@/components/input/InputForm.vue";
import InputTextField from "@/components/input/InputTextField.vue";
import InputRadio from "@/components/input/InputRadio.vue";

import { NewUserData } from "@/interfaces";

import ViewNew from "@/views/new-views/ViewNew.vue";
import { NApi, NApiError } from "@/interfaces/connector";

@Options({
  components: {
    ViewNew,
    InputButton,
    InputForm,
    InputTextField,
    InputRadio,
  },
})
export default class NewUser
  extends NewRecord<NewUserData, null>
  implements NewUserData {
  public API_CALL = NApi.newUser;
  public BACK = "/osoby";

  public name = "";
  public surname = "";
  public email = "";
  public perm_id = 0;
  public password = "";

  public perms: { id: number; display_name: string }[] = [];

  public mounted() {
    this.load_perms();
  }

  public get_data = () => ({
    name: this.name,
    surname: this.surname,
    email: this.email,
    perm_id: this.perm_id,
    password: this.password,
  });

  public load_perms = async () => {
    try {
      const data: any[] = await NApi.getPerms();

      for (const { id, name } of data) {
        this.perms.push({
          id,
          display_name: name,
        });
      }
    } catch (e) {
      console.log(e);
    }
  };
}
</script>

<style lang="scss" scoped>
@import "@/styles/globals";

.error {
  color: $red;
  font-size: 10px;
}
</style>
